'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                FunBox                                    |
'|                                                                          |
'|                         GDImage/OpenGL project                           |
'|                                                                          |
'|                      Skin Engine for VISTA and XP                        |
'|           with full crystal and blur effect in composited mode           |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-06-2007 (MM-DD-YYYY)            |
'|                        Last revised : 04-09-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "FunBox.exe"
'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%FW_BOLD                  = 700
%GWL_WNDPROC              = -4
%WS_EX_STATICEDGE         = &H00020000

%HKEY_LOCAL_MACHINE       = &H80000002???
%HKEY_CURRENT_USER        = &H80000001???
%REG_SZ                   = 1     ' Unicode nul terminated string
%STANDARD_RIGHTS_READ     = &H00020000
%STANDARD_RIGHTS_WRITE    = &H00020000
%KEY_QUERY_VALUE          = &H1
%KEY_SET_VALUE            = &H2
%KEY_CREATE_SUB_KEY       = &H4
%KEY_ENUMERATE_SUB_KEYS   = &H8
%KEY_NOTIFY               = &H10
%SYNCHRONIZE              = &H00100000


TYPE DEV_BROADCAST_HDR
  dbch_size       AS DWORD
  dbch_devicetype AS DWORD
  dbch_reserved   AS DWORD
END TYPE

TYPE DEV_BROADCAST_VOLUME
  dbch_size       AS DWORD
  dbch_devicetype AS DWORD
  dbch_reserved   AS DWORD
  dbcv_unitmask   AS DWORD
  dbcv_flags      AS WORD
END TYPE

TYPE FILETIME
  dwLowDateTime AS DWORD
  dwHighDateTime AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS DWORD
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS DWORD
  dwReserved1 AS DWORD
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternateFileName AS ASCIIZ * 14
END TYPE

%WM_DEVICECHANGE          = &H219
%DBTF_MEDIA               = &H1&     ' media comings and goings
%DBT_DEVTYP_VOLUME        = &H2&     ' logical volume
%DBT_DEVICEARRIVAL        = &H8000&  ' system detected a new devic
%DBT_DEVICEREMOVECOMPLETE = &H8004&  ' device is gone
%DRIVE_UNKNOWN            = 0
%DRIVE_NO_ROOT_DIR        = 1
%DRIVE_REMOVABLE          = 2
%DRIVE_FIXED              = 3
%DRIVE_REMOTE             = 4
%DRIVE_CDROM              = 5
%DRIVE_RAMDISK            = 6
DECLARE FUNCTION RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GetDriveType LIB "KERNEL32.DLL" ALIAS "GetDriveTypeA" (nDrive AS ASCIIZ) AS DWORD

%WM_DROPFILES = &H233

%PFD_TYPE_RGBA                  = 0
%PFD_DOUBLEBUFFER               = &H00000001
%PFD_DRAW_TO_WINDOW             = &H00000004
%PFD_DRAW_TO_BITMAP             = &H00000008
%PFD_SUPPORT_OPENGL             = &H00000020

%GL_DEPTH_BUFFER_BIT            = &H00000100
%GL_COLOR_BUFFER_BIT            = &H00004000
%GL_MODELVIEW                   = &H1700
%GL_LIGHTING                    = &H0B50
%GL_LIGHT0                      = &H4000
%GL_COLOR_MATERIAL              = &H0B57
%GL_DIFFUSE                     = &H1201
%GL_SPECULAR                    = &H1202
%GL_SHININESS                   = &H1601
%GL_FRONT_AND_BACK              = &H0408
%GL_AMBIENT                     = &H1200
%GL_POSITION                    = &H1203
%GL_QUADS                       = &H0007

DECLARE FUNCTION wglCreateContext LIB "OPENGL32.DLL" ALIAS "wglCreateContext" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE FUNCTION SwapBuffers LIB "GDI32.DLL" ALIAS "SwapBuffers" (BYVAL hDC AS DWORD) AS LONG
DECLARE SUB glPushMatrix LIB "OPENGL32.DLL" ALIAS "glPushMatrix" ()
DECLARE SUB glPopMatrix LIB "OPENGL32.DLL" ALIAS "glPopMatrix" ()
DECLARE SUB glTranslated LIB "OPENGL32.DLL" ALIAS "glTranslated" ( BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE )
DECLARE SUB glBegin LIB "OPENGL32.DLL" ALIAS "glBegin" (BYVAL mode AS DWORD)
DECLARE SUB glClear LIB "OPENGL32.DLL" ALIAS "glClear" (BYVAL mask AS DWORD)
DECLARE SUB glColor3ub LIB "OPENGL32.DLL" ALIAS "glColor3ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE)
DECLARE SUB glEnable LIB "OPENGL32.DLL" ALIAS "glEnable" (BYVAL cap AS DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL cap AS DWORD)
DECLARE SUB glEnd LIB "OPENGL32.DLL" ALIAS "glEnd" ()
DECLARE SUB glLoadIdentity LIB "OPENGL32.DLL" ALIAS "glLoadIdentity" ()
DECLARE SUB glMatrixMode LIB "OPENGL32.DLL" ALIAS "glMatrixMode" (BYVAL mode AS DWORD)
DECLARE SUB glRotated LIB "OPENGL32.DLL" ALIAS "glRotated" (BYVAL angle AS DOUBLE, BYVAL x AS DOUBLE, BYVAL y AS DOUBLE, BYVAL z AS DOUBLE)
DECLARE SUB glShadeModel LIB "OPENGL32.DLL" ALIAS "glShadeModel" (BYVAL mode AS DWORD)
DECLARE SUB gluLookAt LIB "glu32.dll" ALIAS "gluLookAt" (BYVAL eyex#, BYVAL eyey#, BYVAL eyez#, BYVAL centerx#, BYVAL centery#, BYVAL centerz#, BYVAL upx#, BYVAL upy#, BYVAL upz AS DOUBLE)
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glVertex3d LIB "OPENGL32.DLL" ALIAS "glVertex3d" (BYVAL x AS DOUBLE, BYVAL y AS DOUBLE, BYVAL z AS DOUBLE)
DECLARE SUB glViewport LIB "OPENGL32.DLL" ALIAS "glViewport" (BYVAL x&, BYVAL y&, BYVAL nwidth&, BYVAL height&)
DECLARE FUNCTION wglDeleteContext LIB "OPENGL32.DLL" ALIAS "wglDeleteContext" (BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB glFrustum LIB "OPENGL32.DLL" ALIAS "glFrustum" (BYVAL nleft AS DOUBLE, BYVAL nright AS DOUBLE, BYVAL bottom AS DOUBLE, BYVAL top AS DOUBLE, BYVAL zNear AS DOUBLE, BYVAL zFar AS DOUBLE)
DECLARE SUB glClearColor LIB "OPENGL32.DLL" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL cAlpha AS SINGLE)
DECLARE SUB glLightfv LIB "opengl32.dll" ALIAS "glLightfv" (BYVAL light AS DWORD, BYVAL pname AS DWORD, params AS ANY)
DECLARE SUB glMaterialfv LIB "opengl32.dll" ALIAS "glMaterialfv" (BYVAL face AS DWORD, BYVAL pname AS DWORD, params AS ANY)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL LONG, textures AS ANY)
DECLARE SUB glFlush LIB "opengl32.dll" ALIAS "glFlush" ()
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glRotatef LIB "opengl32.dll" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL s AS SINGLE, BYVAL t AS SINGLE)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)

DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS LONG

%XMIN_SIZE = 800
%YMIN_SIZE = 510

%ID_VISUAL              = -1

%ID_UP                  = 1
%ID_LEFT                = 2
%ID_RIGHT               = 3
%ID_DOWN                = 4
%ID_NEW_IMAGE           = 5
%ID_STOP                = 6

%ID_TRACK_ZOOM          = 14
%ID_RESET               = 27

%ID_FRAMEBUTTON         = 29
%ID_GLASS_OPACITY_LABEL = 30
%ID_TRACK_OPACITY       = 31
%ID_AEROCRYSTAL         = 32
%ID_AEROBLUR            = 33

%ID_Background          = 35

%ID_BTN_ABOUT           = 41

%ID_BTN_BACKL           = 42
%ID_BTN_BACKR           = 43

%ID_BTN_HELP            = 44
%ID_TAG_TITLE           = 45

%AERO_TIMER             = 1
%VISUAL_TIMER           = 2

GLOBAL gGLWnd, gMainWnd, gWasGLproc AS DWORD
' OpenGL globals, defines, and prototypes
GLOBAL gYincr, gXincr, gDistance, gSpinX, gSpinY AS SINGLE

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

' We need this to share UseFont among procedures 
SUB GlobalFont(UseFont AS ZGLFONT, BYVAL RW AS LONG)
    STATIC WasFont AS ZGLFONT
    IF RW THEN WasFont = UseFont
    UseFont = WasFont
END SUB

' Perform smooth moving of the OpenGL graphic while using the left mouse button
FUNCTION glWndProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORt AS LONG
    LOCAL pt AS POINTAPI
    STATIC wasX AS LONG, wasY AS LONG, bMousing AS LONG
    STATIC ptLastMousePosit AS POINTAPI
    STATIC ptCurrentMousePosit AS POINTAPI

  ' Detect mouse activity to compute new Image coordinates
    SELECT CASE LONG wMsg
    CASE %WM_LBUTTONDOWN
          IF bMousing = %FALSE THEN
             pt.x = LOWRD(lParam): pt.y = HIWRD(lParam)
             ptLastMousePosit.x = pt.x
             ptCurrentMousePosit.x = pt.x
             ptLastMousePosit.y = pt.y
             ptCurrentMousePosit.y = pt.y
             bMousing = 1
          END IF
          IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_LBUTTONUP
          bMousing = 0

    CASE %WM_MOUSEMOVE
          pt.x = LOWRD(lParam): pt.y = HIWRD(lParam)
        ' Make sure left mouse button is still down, if not bail out.
          IF ZI_IsLButtonDown = 0 THEN
             bMousing = 0
          ELSE
             IF wasX <> pt.x OR wasY <> pt.y THEN
                ptCurrentMousePosit.x = pt.x
                ptCurrentMousePosit.y = pt.y
                IF bMousing THEN
                   gSpinX = gSpinX - (ptCurrentMousePosit.x - ptLastMousePosit.x)
                   gSpinY = gSpinY - (ptCurrentMousePosit.y - ptLastMousePosit.y)
                END IF
                ptLastMousePosit.x = ptCurrentMousePosit.x
                ptLastMousePosit.y = ptCurrentMousePosit.y
             END IF 
             wasX = pt.x: wasY = pt.y
             'CALL DrawTheScene()
          END IF
    END SELECT

    IF gWasGLproc THEN
       FUNCTION = CallWindowProc(gWasGLproc, hWnd, wMsg, wParam, lParam)
    END IF
END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL UseFont     AS ZGLFONT
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZFUNBOX"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "FunBox"
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "DreamBox.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

'         // To perform file drag and drop
          CALL DragAcceptFiles(gMainWnd, %TRUE)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

'         // Show GDImage OpenGL image texture 
          CALL ZI_ResizeGLWindow(gGLWnd)
          CALL DrawTheScene()

          CALL SetTimer(gMainWnd, %VISUAL_TIMER, 33, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
             IF Msg.message = %WM_KEYDOWN AND Msg.wParam = %VK_F1 THEN
                CALL zPutFocusOn(zGetMainItem(%ID_BTN_HELP))
             ELSE
                IF Msg.hwnd = gGLWnd AND (Msg.message > 255 AND Msg.message < 266) THEN
                   CALL TranslateMessage(Msg)
                   CALL DispatchMessage(Msg)
                ELSE
                   IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                      CALL TranslateMessage(Msg)
                      CALL DispatchMessage(Msg)
                   END IF
                END IF
             END IF
          WEND
          CALL KillTimer(gMainWnd, %VISUAL_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // Delete the OpenGL font
       CALL GlobalFont(UseFont, 0): CALL ZI_DeleteGLFont(UseFont)

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Fill the bakground listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind, BackgroundCount, nSelected AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = zsExePath() + "Background\"

    hList = zGetMainItem(%ID_Background)
    CALL ListDeleteAll(hList)

    WashFind = FindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR BackgroundCount
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    nSelected = ListFindString(hList, zBackground)
    CALL ListSelectPlus(hList, nSelected)

    IF BackgroundCount < 2 THEN
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
    END IF

END SUB

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hList, hCtrl AS LONG
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    vgW = 598: vgH = 425
    zClass = $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = %WS_EX_STATICEDGE
    gGLWnd = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           14, _                      ' initial x position
                           72, _                      ' initial y position
                           vgW, _                     ' Calculate Window Width
                           vgH, _                     ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %ID_VISUAL, _              ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gGLWnd, %ANCHOR_HEIGHT_WIDTH)
'   Load any of the supported GDImage graphic format to create a texture
    sImageName = "Porsche Cayman.jpg"
    'sImageName = "Porsche.png"
    IF ZI_SetGLTextureFromFile((sImageName)) = 0 THEN ' There is no OpenGL error
'      Setup the color background
       CALL ZI_InitGLControl(ZD_ColorARGB(255, RGB(30,37,55)))
       CALL InitializeGL()

       DIM UseFont AS ZGLFONT 
       UseFont.fontName = "Time Roman"
       UseFont.fontHeight = 12
       UseFont.fontWeight = %FW_BOLD
       CALL ZI_BuildGLfont(ZI_GetGLDC(gGLWnd), UseFont) ' Build OpenGL font for our OpenGL window
       CALL GlobalFont(UseFont, 1)
       
'      Subclass control procedure
       gWasGLproc = SetWindowLong(gGLWnd, %GWL_WNDPROC, CODEPTR(glWndProc))
    END IF

'   ___________________

'    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "frame3d.png"), "", 623, 72, 158, 373, %ID_FRAMEBUTTON, 0)
    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Aero.png"), "", 623, 72, 158, 373, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_HEIGHT_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'   ___________________

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Up.png"), 581 + 104, 93, %ID_UP, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change rotation angle value")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Left.png"), 550 + 104, 124, %ID_LEFT, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change rotation angle value")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Pause.png"), 581 + 104, 124, %ID_STOP, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Stop rotation")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Right.png"), 613 + 104, 124, %ID_RIGHT, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change rotation angle value")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Down.png"), 581 + 104, 156, %ID_DOWN, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Change rotation angle value")

    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 632, 190, 140, 14, %ID_TRACK_ZOOM, -180, -1, -45, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Zoom")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Reset.png"), 581 + 104, 215, %ID_RESET, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Restore default value")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "MyPictures.png"), 576 + 104, 280, %ID_NEW_IMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Select a new picture")


IF Vista() AND zDwmIsCompositionEnabled() THEN
    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Blur mode", 631, 361, 75, 22, %ID_AEROBLUR, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch Skin display to BLUR mode")

    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Crystal", 713, 361, 60, 22, %ID_AEROCRYSTAL, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Switch Skin display to CRYSTAL mode")

    hCtrl = zStaticLabelEx(gMainWnd, "Client zone opacity", 632, 382, 140, 15, %ID_GLASS_OPACITY_LABEL, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)

    CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
    'hCtrl = zTrackbar(gMainWnd, (SK_FOLDER() + "BTN_Thumb.png"), 632, 397, 140, 14, %ID_TRACK_OPACITY, 0, 255, cAlpha, SK_TRACKHICOLOR())
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 632, 397, 140, 14, %ID_TRACK_OPACITY, 0, 255, cAlpha, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "To change client opacity (AERO must be On)")
END IF

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, gMainWnd, %ID_Background, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), 18, 31, %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zStaticLabelEx(gMainWnd, "", 120, 37, 650, 15, %ID_TAG_TITLE, SK_ACTIVECAPTION(), %BS_LABEL_LEFT, 1)
    CALL UpdateTitle(sImageName)

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 659, 464, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)
    IF ChangeBackground THEN CALL zUpdateWindow(hWnd, 0)

    IF IsWindowVisible(gGLWnd) THEN
       CALL ZI_ResizeGLWindow(gGLWnd)
       CALL DrawTheScene()
    END IF
END SUB

SUB SetDefault()
    gDistance = -2.5 '3.0
    gSpinX    = 0
    gSpinY    = 0
    gYincr    = 0
    gXincr    = 0
END SUB

' Set up our OpenGL scene
SUB InitializeGL()
 
    CALL SetDefault()

    'CALL glShadeModel(%GL_SMOOTH)                                 ' Enable Smooth Shading
    'CALL glHint(%GL_PERSPECTIVE_CORRECTION_HINT, %GL_NICEST)      ' Do nicest perspective

    DIM LightAmbient(3) AS SINGLE:  ARRAY ASSIGN LightAmbient()  = 0.05, 0.05, 0.05, 1.0
    DIM LightDiffuse(3) AS SINGLE:  ARRAY ASSIGN LightDiffuse()  = 1.0, 1.0, 1.0, 1.0
    DIM LightPosition(3) AS SINGLE: ARRAY ASSIGN LightPosition() = 20.0, 0.0, 30.0, 1.0
    CALL glLightfv(%GL_LIGHT0, %GL_AMBIENT, LightAmbient(0))      ' Setup The Ambient Light
    CALL glLightfv(%GL_LIGHT0, %GL_DIFFUSE, LightDiffuse(0))      ' Setup The Diffuse Light
    CALL glLightfv(%GL_LIGHT0, %GL_POSITION, LightPosition(0))    ' Position The Light
    CALL glEnable(%GL_LIGHT0)                                     ' Enable Light ZERO
    CALL glEnable(%GL_LIGHTING)                                   ' Enable Lighting
    CALL glEnable(%GL_COLOR_MATERIAL)                             ' Enable Coloring Of Material

END SUB

SUB DrawTheScene()
    LOCAL rc AS RECT, UseFont AS ZGLFONT, StepValue AS LONG
    STATIC UseColor AS LONG, zText AS ASCIIZ * 128, UseStep AS LONG
'   // For marquee text effect
    STATIC xT, yT, stW, stH AS LONG

    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

    gSpinX = (gSpinX + gXincr) MOD 360
    gSpiny = (gSpinY + gYincr) MOD 360
       
    CALL glMatrixMode( %GL_MODELVIEW )
    CALL glLoadIdentity()
    CALL glTranslatef(0.0, 0.0, gDistance)
    CALL glRotatef(-gSpinY, 1.0, 0.0, 0.0)
    CALL glRotatef(-gSpinX, 0.0, 1.0, 0.0)
     
    CALL glBegin(%GL_QUADS)
     ' Front Face
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Top Left Of The Texture And Quad
    CALL glEnd()

    CALL GlobalFont(UseFont, 0)
    StepValue = 2
    IF stW = 0 THEN
       zText = "GDImage does OpenGL"
       CALL ZI_GetGLTextExtent(gGLWnd, UseFont, zText, stW, stH)
       UseColor = ZD_ColorARGB(255, RGB(64,64,92))
       UseStep = -StepValue
       xT = rc.nRight - stw
    END IF
    CALL GetClientRect(gGLWnd, rc)
    yT = rc.nBottom - stH - 10
    xT = xT + UseStep: IF xT < 0 THEN xT = 0: UseStep = StepValue
    IF xT > rc.nRight - stw THEN xT = rc.nRight - stw: UseStep = -StepValue
    CALL ZI_DrawGLText(gGLWnd, UseFont, xT, yT, zText, UseColor)

    CALL ZI_UpdateGLWindow(gGLWnd)
    CALL ZI_UpdateWindow(gGLWnd, 0)
    
    IF ZI_IsLButtonDown() THEN
       SELECT CASE LONG GetFocus
       CASE GetDlgItem(gMainWnd, %ID_UP)
            gYincr = gYincr + 0.05
       CASE GetDlgItem(gMainWnd, %ID_LEFT)
            gXincr = gXincr + 0.05
       CASE GetDlgItem(gMainWnd, %ID_RIGHT)
            gXincr = gXincr - 0.05
       CASE GetDlgItem(gMainWnd, %ID_DOWN)
            gYincr = gYincr - 0.05
       END SELECT
    END IF

END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL K, nChecked, dwData, nRet, wP, hDC, hDCmem, nFilesDropped, hList, hCtrl, nCount, nItem, Img, hFound AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL cAlpha, Red, Green, Blue AS BYTE
    LOCAL sDataString AS STRING, nCheck AS LONG, zPlayList AS ASCIIZ * %MAX_PATH

    STATIC IsMoving AS LONG

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_TRACK_ZOOM
              CALL ZI_SetGLzoom(gGLWnd, zGetTrackValue(zGetMainItem(%ID_TRACK_ZOOM)) * -1)
              CALL ZI_ResizeGLWindow(gGLWnd)

         CASE %ID_RESET
              CALL SetDefault()
              CALL ZI_SetGLzoom(gGLWnd, 0): CALL ZI_ResizeGLWindow(gGLWnd)
              CALL ZI_SetGLzoom(gGLWnd, ZI_GetGLzoom(gGLWnd) * -1): CALL ZI_ResizeGLWindow(gGLWnd)
              CALL DrawTheScene()

         CASE %ID_STOP
              gYincr = 0.0: gXincr = 0.0

         CASE %ID_NEW_IMAGE
              sFilName$ = ZI_LoadDialog(hWnd)
              IF LEN(sFilName$) THEN
                 CALL ZI_SetGLTextureFromFile((sFilName$))
                 CALL UpdateTitle(sFilName$)
              END IF

         CASE %ID_AEROCRYSTAL
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(0, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_AEROBLUR
              IF zGetCheckButtonStatus(zGetMainItem(%ID_AEROBLUR)) THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(zGetTrackValue(zGetMainItem(%ID_TRACK_OPACITY)), RGB(Red, Green, Blue)), %WRITE)
                 CALL zSetCheckButtonStatus(zGetMainItem(%ID_AEROCRYSTAL), %FALSE)
                 CALL zAEROEMULATE(%TRUE, %WRITE)
                 CALL zAEROBLURLEVEL(6, %WRITE)
                 CALL SetTimer(hWnd, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)

                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)
                 CALL zUSEVISTABLUR(%TRUE, %WRITE)
                 '//CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)

              ELSE
                 '//CALL zTEXTRENDERING(%TextRenderingDefault, 1)
                 CALL KillTimer(hWnd, %AERO_TIMER)
                 CALL zAEROEMULATE(%FALSE, %WRITE)

                 CALL zUSEVISTABLUR(%FALSE, %WRITE)
                 CALL zUSEVISTACRYSTAL(%FALSE, %WRITE)

                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_SHOW)
                 CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_SHOW)

              END IF
              CALL GetWindowRect(hWnd, rc)
              CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
              CALL zUpdateWindow(hWnd, 0)
         CASE %ID_TRACK_OPACITY
              IF SK_AEROEMULATE() THEN
                 CALL zSplitColorARGB(SK_AEROCOLOR(), cAlpha, Red, Green, Blue)
                 CALL zAEROCOLOR(zColorARGB(lParam, RGB(Red, Green, Blue)), %WRITE)
                 CALL GetWindowRect(hWnd, rc)
                 CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                 CALL zUpdateWindow(hWnd, 0)
              END IF

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_BACKL
              hList = zGetMainItem(%ID_Background)
              nItem = ListGetCursel(hList)
              IF nItem > 1 THEN
                 DECR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = ListCount(hList)
                 CALL ListSelectPlus(hList, nItem)
              END IF
              Img = zCreateImageFromFile((ListGetText(hList, nItem)))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (ListGetText(hList, nItem)), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)
              END IF

         CASE %ID_BTN_BACKR
              hList = zGetMainItem(%ID_Background)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN
                 INCR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = 1
                 CALL ListSelectPlus(hList, nItem)
              END IF
              Img = zCreateImageFromFile((ListGetText(hList, nItem)))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (ListGetText(hList, nItem)), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)
              END IF

         CASE %ID_BTN_HELP

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'   //START AERO section ---------------------------------------------------------
    CASE %WM_TIMER
         IF wParam = %VISUAL_TIMER THEN
            CALL DrawTheScene()
            FUNCTION = 0: EXIT FUNCTION
         ELSE
            IF zDwmIsCompositionEnabled() = 0 THEN
               IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
                  IF zIsLButtonDown() = 0 THEN IsMoving = 0
                  IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                     CALL GetWindowRect(hWnd, rc)
                     CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                     CALL zUpdateWindow(hWnd, 0)
                  END IF
               END IF
            END IF
         END IF

    CASE %WM_NCLBUTTONDOWN
         IsMoving = -1

    CASE %WM_MOVING
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               DIM rw AS RECT PTR
               rw = lparam
               CALL zMoveBackground(@rw.nLeft, @rw.nTop, 0)
               CALL zUpdateWindow(hWnd, 0)
               FUNCTION = 1: EXIT FUNCTION
            END IF
         END IF
'   //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB UpdateTitle(BYVAL sFilName AS STRING)
    LOCAL So AS LONG
    CALL zSplitN((sFilName), "", sFilName)
    So = INSTR(-1, sFilName, "."): IF So THEN sFilName = LEFT$(sFilName, So - 1)
    CALL zSetCTLText(zGetMainItem(%ID_TAG_TITLE), (UCASE$(sFilName)))
END SUB
